      subroutine Manual_Calibration(totKK)

      implicit none

      include 'DimArrays.inc'
      include 'comVar.inc'
      include 'comRead.inc'
      include 'comRainRun.inc'


      integer nvent,NRIGHE,TotOss,depo1,totpl,chkPL,m,chkTE
      integer p,npf,PasPio,I,J,K,L,LL,Nstep,depo,nums,totKK,anno,KK
      integer manP(Nraing),manT(Ntermo),STpn(NRow,NCol),STtn(NRow,NCol)
      real tot,contg,totale,INVpn(NRow*Nraing,NCol),PioN(NRow,NCol)
      

      call Initial_value  ! inizialization of global arrays

      KK=1        
      Nstep=NOss*(StepPio/DT)
      K=1        
      anno=1
      contg=0.           ! the evapotranspiration formula requires the updating
      m=mm               ! of the current simulation month
      totale=totg     
      do while (K.LE.Nstep)
         PasPio=(DT/StepPio)*(K-1.)+1
         depo=K/(8760*(StepPio/DT))
         depo1=K-(depo*8760*StepPio/DT)
         if (depo1.EQ.0) then
            write(*,*) 'Year ',anno,' completed'
            anno=anno+1
         end if

         chkPL=0
         totpl=0
         do p=1,Nplu  ! checking the availability of rainfall data for the current time step
            if (FGPIO(PasPio,p).EQ.1) then
C              rainfall data is missing at raingauge p
               chkPL=1
               totpl=totpl+1
               manP(totpl)=p
            end if
         end do

         if (chkPL.EQ.1) then
            if (risp2.EQ.1) then
C              application of the Thiessen method by excluding the raingauges with 
C              missing data whose number is stored in manP()
               call NewThiessen(Nplu,Coordp,totpl,manP,STpn,Slope)
            else
C              application of the inverse distance method by excluding the raingauges 
C              with missing data whose number is stored in manPp()
               call NewInvDist(Nplu,Coordp,totpl,manP,INVpn,Slope)
            end if
         end if

C        initialization of the array of the surface runoff intensity
         do I=1,idim
            do J=1,jdim
               PioN(I,J)=0.
            end do
         end do
         if (risp.EQ.2) then
C           simulation of a single rainfall event with the CN method or simulation
C           of an impervious catchment
            call CN_method(PasPio,chkPL,PioN,STpn,INVpn)                    
         else
C           continuous rainfall-runoff simulation
C           checking the availability of the temperature data
            call Check_temp(PasPio,K,Nstep,chkTE,STtn,manT)
            call Continuous(PasPio,K,Nstep,m,chkPL,chkTE,
     .                      STtn,PioN,STpn,INVpn)
            call Update_day(contg,totale,m)  
         end if

C        Routing procedure
         call Routing(PioN) 

         if (Nmis.GT.0) then
            do LL=1,Nmis
               Qsup(KK,LL)=Q(outI(LL),outJ(LL))
               Qtot(KK,LL)=Q(outI(LL),outJ(LL))+QI(outI(LL),outJ(LL))                               
            end do
           KK=KK+1
         end if

C        updating the arrays of the surface flow
         do I=1,idim
            do J=1,jdim
               Y(I,J)=Q(I,J); YY(I,J)=QQ(I,J)
               Q(I,J)=0.; QQ(I,J)=0.
               YI(I,J)=QI(I,J); YYI(I,J)=QQI(I,J)
               QI(I,J)=0.; QQI(I,J)=0.
            end do
         end do

       open(unit=30,file='timestep.out')
       write(30,*) 'Completed time step ',K,'/',Nstep
       close(30)
         K=K+1                
      end do
            
      totKK=KK-1
      
      return
      end
